const COOKIE_CLEAR = ['_sId=null; HttpOnly; Path=/', '_uId=null; HttpOnly; Path=/', '_oId=null; HttpOnly; Path=/', '_sysId=null; HttpOnly; Path=/', '_public=null; HttpOnly; Path=/', 'AIMAGIN_ACCESS_TYPE=null; Path=/', '_server='+SYSTEM.serverType+'; Path=/'];

module_auth_getPermission = function(db, roleId, callback) {
    db.all("SELECT id, name, admin, webApp, page, database, filter_status, filter_data, module FROM tbl001 WHERE id IN (" + roleId.split("|").map(d=>("'"+d+"'")).join(",")+")", [], callback);
};

module_auth_readSysId =  (oId)=>fs.existsSync(SYSTEM.path+"/systems/oId/"+oId)?fs.readFileSync(SYSTEM.path+"/systems/oId/"+oId, "utf8"):null;

module_auth_getSysId = function(system, oId, callback) {
    if(SYSTEM.serverType=="on-site" || SYSTEM.serverType=="esp32") {
        callback(true);
    } else {
        /*---Server only---*/
        let sysId = null;
        if(oId!=null) {
            sysId = module_auth_readSysId(oId)
        } else {
            if(system.oId!=null) {
                sysId = module_auth_readSysId(system.oId);
            }
            if(sysId==null) {
                if(system.oId!=null) {
                    system.defaultPage = false;
                }
                system.oId = system.cookie._oId;
                sysId = module_auth_readSysId(system.oId);
            }
        }
        if(sysId!=null) {
            system.sysId = sysId;
            system.sysPath = SYSTEM.path + "systems/" + system.sysId;
        } else {
            system.sysPath = null; 
        }
        callback(system.sysPath!=null);
        /*---Server only---*/
    }
}

module_auth_logIn = function(system, oId, username, password, callback) {
    module_auth_getSysId(system, oId, (sysId)=>{
        if(sysId==false) {
            callback(false, "err_0_0", COOKIE_CLEAR);
        } else {
            let db = new sqlite3.Database(system.sysPath+"/db/system.db");
            db.parallelize(()=>{
                db.get("SELECT * FROM tbl000 WHERE lower(email)=? AND password=?;", [username.toLowerCase(), module_core_hash(password)], (err, user)=>{
                    if(user==undefined) {
                        callback(false, "err_0_0", COOKIE_CLEAR);
                    } else {
                        if(user.status=="1" && user.roleId!="") {
                            let ms = module_core_getTimeMsStr(), sId = module_core_genId(512);
                            db.run("UPDATE tbl000 SET sessionId = ?, time_logIn = ?, time_ping = ? WHERE userId=?;", [sId, ms, ms, user.userId], (err)=>{
                                module_auth_getPermission(db, user.roleId, function(err, role) {
                                    db.close();
                                    system.role = role;
                                    system.user = user;
                                    system.conf = JSON.parse(fs.readFileSync(system.sysPath+"/conf/conf.json"));
                                    callback(true, null, ['_sId='+sId+'; HttpOnly; Path=/', '_uId='+user.userId+'; HttpOnly; Path=/', '_oId='+oId+'; HttpOnly; Path=/', '_sysId='+system.sysId+'; HttpOnly; Path=/']);
                                });
                            });
                        } else {
                            db.close();
                            callback(false, user.status=="0"?"err_0_1":"err_0_2", COOKIE_CLEAR);
                        }
                    }
                });
            });
        }
    });
}

moudule_auth_genPublicCookie = function(system, callback) {
    module_auth_getSysId(system, system.oId, (sysId)=>{
        callback(['_oId='+system.oId+';HttpOnly; Path=/', '_sysId='+system.sysId+';HttpOnly; Path=/', '_sId=null; HttpOnly; Path=/', '_public=true; HttpOnly; Path=/', 'AIMAGIN_ACCESS_TYPE=public; Path=/']);
    });
}

module_auth_authenticate = function(system, callback) {
    if(system.cookie._sId!="null") {
        module_auth_getSysId(system, null, function(result){
            if(result==false) {
                callback(false, "err_1_4", COOKIE_CLEAR);
            } else {
                let db = new sqlite3.Database(system.sysPath+"/db/system.db");
                db.get("SELECT * FROM tbl000 WHERE sessionId = ? AND userId = ?", [system.cookie._sId, system.cookie._uId], function(err, user){
                    if(user==undefined) {                        
                        callback(false, "err_1_3", COOKIE_CLEAR);
                    } else {
                        if(user.status=="1" && user.roleId!="") {
                            let sId = user.sessionId;
                            delete user.sessionId;
                            delete user.password;
                            system.user = user;
                            system.conf = JSON.parse(fs.readFileSync(system.sysPath+"/conf/conf.json"));
                            module_auth_getPermission(db, user.roleId, function(err, role) {
                                system.role = role;
                                callback(true, null, ['_sId='+sId+'; HttpOnly; Path=/', '_uId='+user.userId+'; HttpOnly; Path=/', '_oId='+system.oId+'; HttpOnly; Path=/']);
                                module_core_recordRequestLog(system, user.email, 'page', {});
                            });
                        } else {
                            callback(false, user.status=="0"?"err_1_1":"err_1_2", COOKIE_CLEAR);
                        }
                    }
                    db.close();
                });
            }
        });
    } else if(system.defaultPage==true) {
        callback(false, null, COOKIE_CLEAR);
    } else {
        module_auth_getSysId(system, null, function(sysId){
            if(sysId==false) {
                callback(false, "err_1_4", COOKIE_CLEAR);
            } else {
                system.user = {userId:"Public"};
                system.role = [{id:"public", name:"public", webApp:"", database:"cru", page:"", module:""}];
                system.conf = JSON.parse(fs.readFileSync(system.sysPath+"/conf/conf.json"));                
                callback(true, null, ['_sId=null; HttpOnly; Path=/', '_uId=null; HttpOnly; Path=/', '_public=true; HttpOnly; Path=/', '_oId='+system.oId+';HttpOnly; Path=/']);                        
            }
        });
    }    
}

module_auth_logOut = function(system, callback) {
    module_auth_getSysId(system, system.cookie._oId, (sysId)=>{
        if(sysId==true) {
            let db = new sqlite3.Database(system.sysPath+"/db/system.db");
            db.run("UPDATE tbl000 SET sessionId = null WHERE userId=?;", [system.cookie._uId], (err)=>{
                callback(COOKIE_CLEAR);
            });
            db.close();
        } else {
            callback(COOKIE_CLEAR);
        }
    });
}